<template lang="pug">
	ul.movie-list: li(v-for="movie in validMovies", :key="movie.url"): MovieBlock(:movie="movie")
</template>

<script>
	import { Movie } from '~/classes/Movie';

	const MovieBlock = async () => await import('~/views/MovieBlock');

	export default {
		name: 'MovieList',
		components: { MovieBlock },
		props: {
			movies: {
				type: Array,
				required: true,
				default: () => []
			}
		},
		computed: {
			validMovies () {
				return this.movies
					.filter(movie => movie instanceof Movie)
					.sort(({ year: yearA }, { year: yearB }) => {
						if (yearA > yearB) return 1;
						if (yearA < yearB) return -1;

						return 0;
					});
			}
		}
	};
</script>

<style lang="scss" scoped>
	@import "~/scss/variables";

	ul.movie-list {
		$side-padding: 1rem;

		list-style-type: none;
		column-count: 2;
		column-gap: 1rem;
		margin: 0;
		padding: 0 $side-padding;
		column-width: calc((#{$content-width} / 2) - (#{$side-padding} * 2));

		li { break-inside: avoid; }
	}
</style>
